%global name mod_define
%global version 2.1
%global rpmrelease 2

%global _shortname %(eval NAME=%{name} ; echo "${NAME/mod_}")
%global _has_old_httpd %(eval [ $(rpm -q --queryformat '%{VERSION}' httpd-devel | cut -d "." -f 2) -lt 4 ] && echo 1 || echo 0)
%global _httpd_apxs %(eval [ -x %{_sbindir}/apxs ] && echo %{_sbindir}/apxs || echo apxs)
%global _httpd_moddir %{_libdir}/httpd/modules
%global _httpd_confdir %{_sysconfdir}/httpd/conf.d
# only httpd >= 2.4 has /etc/httpd/conf.modules.d
%if ! %{_has_old_httpd}
%global _httpd_modconfdir %{_sysconfdir}/httpd/conf.modules.d
%endif

Summary: Module to define variables for arbitrary directives for the Apache HTTP server
Name: %{name}
Version: %{version}
Release: %{rpmrelease}%{?dist}
License: ASL 2.0
Group: System Environment/Daemons
URL: http://people.apache.org/~rjung/%{name}/
Packager: Simon Matter <simon.matter@invoca.ch>
Vendor: Invoca Systems
Distribution: Invoca Linux Server
Source0: http://people.apache.org/~rjung/%{name}/%{name}.c
Source1: %{name}.conf
Source2: %{name}.mod.conf
Source3: http://people.apache.org/~rjung/%{name}/LICENSE
Source4: http://people.apache.org/~rjung/%{name}/NOTICE
Source5: http://people.apache.org/~rjung/%{name}/README
Source6: http://people.apache.org/~rjung/%{name}/mod_define.html
%if %{_has_old_httpd}
Requires: httpd >= 2.0.0
%else
Requires: httpd >= 2.4.0
%endif
BuildRequires: httpd-devel
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
The Apache HTTPD module %{name} allows to define variables in the web
server configuration files and to use them laterin the files. This
allows to build configurations which are easier to understand and
maintain.

%prep
%setup -c -T
%{__install} -m 0644 -p %{SOURCE0} .
%{__install} -m 0644 -p %{SOURCE3} .
%{__install} -m 0644 -p %{SOURCE4} .
%{__install} -m 0644 -p %{SOURCE5} .
%{__install} -m 0644 -p %{SOURCE6} .

%build
%{_httpd_apxs} -c %{name}.c

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%{__install} -d %{buildroot}%{_httpd_moddir}
%{__install} -d %{buildroot}%{_httpd_confdir}
%if ! %{_has_old_httpd}
%{__install} -d %{buildroot}%{_httpd_modconfdir}
%endif

%{__install} -m 0755 -p .libs/%{name}.so %{buildroot}%{_httpd_moddir}/
%if ! %{_has_old_httpd}
%{__install} -m 0644 -p %{SOURCE1} %{buildroot}%{_httpd_confdir}/%{_shortname}.conf
%{__install} -m 0644 -p %{SOURCE2} %{buildroot}%{_httpd_modconfdir}/10-%{_shortname}.conf
%else
# merge configs for httpd < 2.4
{ %{__cat} %{SOURCE2}
  echo
  %{__cat} %{SOURCE1}
} > merged.conf
touch -c -r %{SOURCE1} merged.conf
%{__install} -m 0644 -p merged.conf %{buildroot}%{_httpd_confdir}/%{_shortname}.conf
%endif

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc LICENSE NOTICE README %{name}.html
%{_httpd_moddir}/%{name}.so
%config(noreplace) %{_httpd_confdir}/%{_shortname}.conf
%if ! %{_has_old_httpd}
%config(noreplace) %{_httpd_modconfdir}/10-%{_shortname}.conf
%endif

%changelog
* Thu Mar 09 2023 Simon Matter <simon.matter@invoca.ch> 2.1-2
- add support for EL9

* Thu May 24 2018 Simon Matter <simon.matter@invoca.ch> 2.1-1
- initial package
